﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGFilterPieChartCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> PieData { get; set; }
        public ObservableCollection<SampleData> GridData { get; set; }

        public ActionCommand<SliceClickEventArgs> SliceClickCommand { get; set; }

        public ViewModel()
        {
            PieData = new ObservableCollection<SampleData>();
            GridData = new ObservableCollection<SampleData>();

            SliceClickCommand = new ActionCommand<SliceClickEventArgs>(OnSliceClick);

            for (int i = 1; i <= 5; i++)
            {
                PieData.Add(new SampleData()
                {
                    Label = "Label " + i.ToString(),
                    Value = i
                });
            }

            foreach (SampleData SD in PieData)
            {
                GridData.Add(SD);
            }
        }

        public void OnSliceClick(SliceClickEventArgs e)
        {
            SampleData SD = e.DataContext as SampleData;
            if (e.IsExploded)
            {
                e.IsExploded = false;
                GridData.Add(SD);
            }
            else
            {
                e.IsExploded = true;
                GridData.Remove(SD);
            }
        }
    }

    public class SampleData
    {
        public string Label { get; set; }
        public int Value { get; set; }
    }
}
